package com.exxeta.samples.jsr352.job;

import java.io.Serializable;

import javax.batch.api.BatchProperty;
import javax.batch.api.chunk.AbstractItemReader;
import javax.inject.Inject;
import javax.inject.Named;

import com.csvreader.CsvReader;

@Named
public class CsvItemReader extends AbstractItemReader {

	private static final char separator = ';';

	@Inject
	@BatchProperty(name = ImportJobLauncher.PARAM_FILE)
	private String csvInputFile;

	private CsvReader reader;

	@Override
    public void open(Serializable checkpoint) throws Exception {
    	reader = new CsvReader(csvInputFile, separator);
    }

    @Override
	public void close() throws Exception {
    	reader.close();
	}

    @Override
    public String[] readItem() throws Exception {
    	if (reader.readRecord()) {
    		return reader.getValues();
    	}
        return null;
    }
}
