package com.exxeta.samples.jsr352.util;

import javax.batch.operations.JobOperator;
import javax.batch.runtime.BatchRuntime;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.inject.Produces;
import javax.enterprise.inject.spi.InjectionPoint;
import javax.faces.context.FacesContext;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This class functions as a CDI bean factory.
 */
public class BeanProducer {

    @Produces
    public Logger produceLogger(InjectionPoint injectionPoint) {
    	return LoggerFactory.getLogger(injectionPoint.getMember().getDeclaringClass().getName());
    }

    @Produces
    public JobOperator produceJobOperator() {
    	return BatchRuntime.getJobOperator();
    }

    @Produces
    @RequestScoped
    public FacesContext produceFacesContext() {
        return FacesContext.getCurrentInstance();
    }
}
